package com.xhkjedu.smarking.service.report.report;

import com.xhkjedu.smarking.mapper.report.reportstu.MsrStudentMapper;
import com.xhkjedu.smarking.mapper.report.reportstu.MsrStudentPointMapper;
import com.xhkjedu.smarking.model.report.reportstu.MsrStudent;
import com.xhkjedu.smarking.vo.report.reportother.ExamReportParams;
import com.xhkjedu.smarking.vo.report.reportstu.StudentParams;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Description：学生报告信息
 * @Author: WN
 * @Date: 2024/12/24 9:50:38
 **/
@Service
public class MsrStudentService {
    @Resource
    private MsrStudentMapper msrStudentMapper;
    @Resource
    private MsrStudentPointMapper msrStudentPointMapper;

    //综合报告-小分表-列表
    public List<Map<String,Object>> listStuScoreAndRank(Integer examid, String subjectid){
        return msrStudentMapper.listStuScoreAndRankByExamidAndSubjectid(examid,subjectid);
    }

    //学生报告-学生各学科试题分析
    public List<Map<String,Object>> listStuSubjectQuestions(ExamReportParams params){
        return msrStudentMapper.listStuSubjectQuestions(params);
    }

    //学生报告-学生各学科知识点分析
    public List<Map<String,Object>> listStuPoints(ExamReportParams params){
        return msrStudentPointMapper.listStuPoints(params);
    }

    /**
     * @Description 综合报告-排行榜
     * @Date 2025/1/6 9:12
     * @Author YWX
     * @Param [params]
     * @Return java.lang.Object
     **/
    public List<Map> listStudentForPhb(StudentParams params) {
        List<String> fields = params.getFields();
        StringBuilder sql = new StringBuilder();
        sql.append("s.rsid");
        boolean user = false;
        if (fields.contains("姓名")) {
            sql.append(",u.username as studentname");
            user = true;
        }
        if (fields.contains("考号")) {
            sql.append(",u.examno");
            user = true;
        }
        if (fields.contains("学号")) {
            sql.append(",u.studentno");
            user = true;
        }
        if (fields.contains("班级")) {
            sql.append(",(select c.classname from t_class c where c.classid=s.classid) as classname");
        }
        if (fields.contains("分数")) {
            sql.append(",s.stuscore");
        }if (fields.contains("等级")) {
            sql.append(",s.gradevalue");
        }if (fields.contains("学校排名")) {
            sql.append(",s.schoolrank");
        }if (fields.contains("班级排名")) {
            sql.append(",s.classrank");
        }if (fields.contains("标准分")) {
            sql.append(",s.bzf");
        }if (fields.contains("超均率")) {
            sql.append(",s.cjl");
        }
        sql.append(" from msr_student s ");
        if (user) {
            sql.append(" inner join t_user u on s.studentid=u.userid ");
        }
        List<Map> list=msrStudentMapper.listStudentForPhb(sql.toString(), params);
        return list;
    }
}
